
;=================================
; Hooker3
; Macro Program
; 100% ASM
; Made by Savage
;=================================

;Quick Notes:
; For strings, surround the parameter with single quotes
;   A string will take up Param1 and Param2, holding the address of the string
;  The scan string (ctrl/alt/shift) is the 'second' parameter, which will be Param3
;*
;for keydown,keyup,and type:
;If param2 is zero, then it is considered a quote
; This means, if you NEED a second parameter with a number, make param#2 equal 0 (Num/0/Third)
; If you NEED a third parameter with a string, use the 'second' parameter (String/String/Third)
; keydown 'h';
; keydown 55;
; keydown 'h',3;
; keydown 55,0,3;       
; 

.386
.MMX
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE


		include Hooker3.inc

	WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
	MouseTrackerProc PROTO :DWORD, :DWORD, :DWORD, :DWORD
	KeyTrackerProc PROTO :DWORD, :DWORD, :DWORD, :DWORD
	HelpDlgProc PROTO :DWORD, :DWORD, :DWORD, :DWORD
	DisplayError PROTO :DWORD, :DWORD
	DWItoDWA PROTO DWI:DWORD
	DWItoDWH PROTO DWI:DWORD
	
	ParseEntireMacro PROTO DisplayErrors:BOOL, LeakString:BOOL
	ParseMacro PROTO DisplayErrors:BOOL, LeakString:BOOL, StartLine:DWORD, NumLines:DWORD
	RunMacro PROTO
	DestructMacro PROTO
	
	atoi PROTO pStr:DWORD
	itoa PROTO i:DWORD, pStr:DWORD
	DWItoQWH PROTO i:DWORD

	SetItemFromList PROTO pItem:DWORD
	GetItemFromList PROTO pItem:DWORD
	DeleteItemFromList PROTO pItem:DWORD

	szCopyx PROTO src:DWORD,dst:DWORD,siz:DWORD
	AtimesB PROTO A:DWORD, B:DWORD
	PixelsToMickeys PROTO pPoint:DWORD
.data
	CurrentErrorMessage DWORD 0

	szDebugText db '1 2 3 4 5 6 7 8 9 10 11 12 13 14 15',0
	
	TOP_ROW_HEIGHT equ 43
	LEFT_COLUMN_WIDTH equ 36
	;@@@@@ Window Classes @@@@@
	szCButton		db 'Button',0
	szCEdit			db 'Edit',0
	szCStatic		db 'Static',0
	szCMouseTracker db 'MouseTracker',0
	szCHelp			db 'Help',0
	;@@@@@ Window Captions @@@@@
	szBtnSend		db 'Send',0
	szMainEdit		db 'wait 1000;',13,10,'type ',27h,'5',27h,';',13,10,'move 50000,23000;',0
  	HOTKEY_START	equ 57
  	HOTKEY_TRACK	equ 58
  	HOTKEY_HALT		equ 59
	
	lpDueTime dq -100000000
	
	
	;@@ Line Numbering
	tempchar			db 10 dup(?) ; stores line# string
	scrolltop			dd 0	
	;@@ Microcode
	; After parsing, indicates the size of the microcode
	OpcodeLineCount dd 0
	; Flag to mark whether we should continue macro or not
	HaltFlag 	dd FALSE
	WaitFlag	dd FALSE
	NextLine dd 0
	
	
	
;=================================
	;@@@@@ Keywords @@@@@
;=================================
	
	
	KW_FLAG_SYNTAX equ 0
	KW_FLAG_RUNTIME equ 07FFFh
	KW_FLAG_BLANK equ 07FFEh
	align 4
	szKeywords	db 'jmp',0
				KW_JMP_INT equ   (kwTotal-1)
				KW_JMP_STR equ (-(kwTotal-1)-1)
				KW_JMP_SIZE equ $-(Offset szKeywords)
				
	__keywordcount = 2
	CreateKeywordEqu MACRO kwName, kwText
	LOCAL tempaa
		result textequ %__keywordcount
		
		% &kwName&_INT		equ (kwTotal-(result))
		% &kwName&_STR		equ (-(kwTotal-(result))-1)
	tempaa db kwText,0
		% &kwName&_SIZE		equ $-(Offset tempaa)
		__keywordcount=__keywordcount+1
	ENDM
	
	;CreateKeywordEqu KW_JMP, 'jmp '
	CreateKeywordEqu KW_MOVE, 		'move'
	CreateKeywordEqu KW_CLICK, 		'click'
	CreateKeywordEqu KW_CLICKDOWN,	'clickdown'
	CreateKeywordEqu KW_CLICKUP,	'clickup'
	CreateKeywordEqu KW_TYPE,		'type'
	CreateKeywordEqu KW_KEYDOWN,	'keydown'
	CreateKeywordEqu KW_KEYUP,		'keyup'
	CreateKeywordEqu KW_WAIT,		'wait'
	CreateKeywordEqu KW_DELTA,		'delta'
	CreateKeywordEqu KW_SET,		'set'
	CreateKeywordEqu KW_LABEL,		'label'
	CreateKeywordEqu KW_CMP,		'cmp'
	CreateKeywordEqu KW_JNE,		'jne'
	CreateKeywordEqu KW_JE,			'je'
	CreateKeywordEqu KW_ADD,		'add'
	CreateKeywordEqu KW_SUB,		'sub'
	CreateKeywordEqu KW_QUIT,		'quit'
	dq 0
	kwTotal equ __keywordcount
	
	
	;tKW_JMP_INT textequ %KW_JMP_INT
	;tKW_JMP_STR textequ %KW_JMP_STR
	
	;% echo tKW_JMP_INT
	;% echo tKW_JMP_STR
	
	;.err
	
;=================================
	;@@@@@ Debug Messages @@@@@
;=================================
	
	ContinueErrorFlag DWORD IDOK
	
		
	runerr    db 'Runtime Error (Keyword #'
	runerrnum db '0000'
			  db ')',0
	synerr db 'Syntax Error',0	
	
	Error_InternalInvalidKeyword db 'INTERNAL Invalid Keyword.',0
	Error_InvalidKeyword db 'Invalid Keyword.',0
	Error_NoSecondQuoteMark db 'Reached end of line before string ended.',0
	Error_NoSemiColon db 'Line must end with a semicolon.',0
	Error_BlankLine db 'Line is blank.',0
	NoErrorMessage db '...',0



	onep db 'one parameter',0
	twop db 'two parameter',0
	trep db 'three parameter',0
	forp db 'more parameter',0
	
	ShitTank dd 32 dup(0)
;=================================
	;@@@@@ Data @@@@@
;=================================
	;@@ mmx
	qSchemeDebug	dq 00000000012345678h
	qDwordConv		dq 000000000FFFFFFFFh
	qNineMask		dq	00909090909090909h
	qAddThirty 		dq 03030303030303030h
	qNibbleMaskH	dq 000000000F0F0F0F0h
	qNibbleMaskL	dq 0000000000F0F0F0Fh
	qSetToSeven		dq 00707070707070707h
	qKillTrailingBytes dq 00000FFFFFFFFFFFFh
	
	myTxColor dd COLOR_BTNTEXT
	myBkColor dd COLOR_3DHIGHLIGHT
	
	rLeftNums		RECT <0,TOP_ROW_HEIGHT,LEFT_COLUMN_WIDTH,?>
	
.data?
	
	;@@@@@ Code Buffer  @@@@@
	MicroCode oword 128 dup(?)
	; Microcode organization:
	;  Instruction:DWORD
	;  Param1	  :DWORD
	;  Param2     :DWORD
	;  Param3     :DWORD
	
	;@@@@@ Text Buffer  @@@@@
	szBufferText db 1024 dup(?)
	
	
	;@@@@@ Random Crap @@@@@
	
	qwOldPos	dq	? 	; for dialog timer, to test if pos is different	
	hDC	dd	?	; DISPLAY dc
	szTempHexColor db 32 dup (?)
	
	;@@@@@ Window Handles @@@@@
	
	IDC_MainEdit	EQU 401
	
	;@@@@@ equs @@@@@
		
	EN_SETFOCUS                 equ 0100h
	EN_KILLFOCUS                equ 0200h
	EN_CHANGE                   equ 0300h
	EN_UPDATE                   equ 0400h
	EN_ERRSPACE                 equ 0500h
	EN_MAXTEXT                  equ 0501h
	EN_HSCROLL                  equ 0601h
	EN_VSCROLL                  equ 0602h
	
	EN_MSGFILTER                equ 0700h
	EN_REQUESTRESIZE            equ 0701h
	EN_SELCHANGE                equ 0702h
	EN_DROPFILES                equ 0703h
	EN_PROTECTED                equ 0704h
	EN_CORRECTTEXT              equ 0705h
	EN_STOPNOUNDO               equ 0706h
	EN_IMECHANGE                equ 0707h
	EN_SAVECLIPBOARD            equ 0708h
	
.CODE
Start:
	invoke GetModuleHandle, NULL
	mov hInstance,eax
	invoke GetProcessHeap
	mov hHeap, eax
	invoke GetCommandLine
	mov CommandLine, eax
	invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
	
WinMain Proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX,
	  msg:MSG,
	  hdc:HDC,
	  hAccelTable:HACCEL,
	  sbParts[4] :DWORD
	  

	;------------------------------------------------
	;	Main Window
	;------------------------------------------------
		;------------------------------------------------
		;	Main Window Register
		;------------------------------------------------
			mov wc.cbSize, SizeOf WNDCLASSEX
			mov wc.style, CS_HREDRAW or CS_VREDRAW
			mov wc.lpfnWndProc, Offset WndProc
			mov wc.cbClsExtra,NULL
			mov wc.cbWndExtra,NULL
			mov eax,hInst
			mov wc.hInstance,eax
			mov wc.hbrBackground, COLOR_WINDOW+1
			mov wc.lpszMenuName, NULL
			mov wc.lpszClassName, Offset ClassName
			invoke LoadIcon, NULL, hookerIcon
			mov wc.hIcon,eax
			invoke LoadImage,hInst, hookerIcon, IMAGE_ICON, 16, 16, 0
			mov wc.hIconSm,eax
			invoke LoadCursor, NULL, IDC_ARROW
			mov wc.hCursor,eax
			invoke RegisterClassEx, addr wc
			invoke LoadMenu, hInst, Offset MenuName
			mov hMenu,eax
			invoke LoadAccelerators,hInstance,myAccelerators
			mov hAccelTable, eax
		;------------------------------------------------
		;	Main Window Create
		;------------------------------------------------
			
			invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR szAppName,\
		           WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,\
		           CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, hMenu,\
		           hInst, NULL
			mov hwnd,eax
			
			
	;------------------------------------------------
	;	Keyboard Window
	;------------------------------------------------
		;------------------------------------------------
		;	Keyboard Window Register
		;------------------------------------------------
			mov wc.cbSize, Sizeof WNDCLASSEX
			mov wc.style, CS_HREDRAW or CS_VREDRAW
			mov wc.lpfnWndProc, Offset KeyTrackerProc
			mov wc.cbClsExtra,NULL
			mov wc.cbWndExtra,NULL
			mov eax,hInst
			mov wc.hInstance,eax
			invoke GetStockObject,LTGRAY_BRUSH
			mov wc.hbrBackground, eax
			mov wc.lpszMenuName, NULL
			mov wc.lpszClassName, Offset KeyTrackerClassName
			invoke LoadIcon, NULL, hookerIcon
			mov wc.hIcon,eax
			invoke LoadImage,hInst, hookerIcon, IMAGE_ICON, 16, 16, 0
			mov wc.hIconSm,eax
			invoke LoadCursor, NULL,IDC_ARROW
			mov wc.hCursor,eax
			invoke RegisterClassEx, ADDR wc
		;------------------------------------------------
		;	Keyboard Window Create
		;------------------------------------------------

			
			
		;------------------------------------------------
		;	Child Windows
		;------------------------------------------------
	
			invoke CreateWindowEx, 0 ,ADDR szCEdit, ADDR szMainEdit, WS_CHILD or WS_VISIBLE or WS_BORDER or  ES_AUTOVSCROLL or WS_VSCROLL or ES_AUTOHSCROLL or WS_HSCROLL or ES_WANTRETURN or ES_MULTILINE  or ES_NOHIDESEL or ES_SELECTIONBAR, 20, 40, 500, 300,hwnd,IDC_MainEdit,hInst,0
			mov hMainEdit, eax
			
			invoke CreateStatusWindow,WS_CHILD or WS_VISIBLE or SBS_SIZEGRIP , $String("def"), hwnd, IDC_STATUS
			mov hStatusBar,eax
			
			
		      
		    ; -------------------------------------
		    ; sbParts is a DWORD array of 4 members
		    ; -------------------------------------
		    mov [sbParts +  0],   250    ; pixels from left
		    mov [sbParts +  4],   350    ; pixels from left
		    mov [sbParts +  8],   475    ; pixels from left
		    mov [sbParts + 12],    -1    ; last part
		
		    invoke SendMessage,hStatusBar,SB_SETPARTS,4,ADDR sbParts

			
			
			.data
			myFontFace db "Elephant",0
			myFontFaceGetKey db "Courier New",0
			hf14 		HFONT ?
			hfGetKey	HFONT ?
			.code
			
			invoke GetDC,0
			mov hdc, eax
			
			;-----------------------------
			; Create Font 14
			;-----------------------------
			
				    invoke GetDeviceCaps,hdc, LOGPIXELSY
				    invoke MulDiv,10, eax, 72
					neg eax
				    invoke CreateFont,eax, 0, 0, 0, 200, 1, 0, 0, 0, 0, 0, 0, 0, Offset myFontFace
					mov hf14, eax
					
					
					
			;-----------------------------
			; Create Font GetKey
			;-----------------------------
			
				    invoke GetDeviceCaps,hdc, LOGPIXELSY
				    invoke MulDiv,24, eax, 72
					neg eax
				    invoke CreateFont,eax, 0, 0, 0, 800, 0, 0, 0, 0, 0, 0, 0, 0, Offset myFontFaceGetKey
					mov hfGetKey, eax
			
			
			invoke ReleaseDC,0,hdc


	;------------------------------------------------
	;	WinMain Code
	;------------------------------------------------
			
		;-----------------------------
		;	Show Window
		;-----------------------------
			
			invoke ShowWindow, hwnd, SW_SHOWNORMAL 
			invoke UpdateWindow, hwnd
			
		;-----------------------------
		;	Message Loop
		;-----------------------------
		
		jmp @F
	StartLoop:
	  invoke TranslateAccelerator, hwnd, hAccelTable, ADDR msg
	  test eax,eax
	  jnz @F
	  invoke TranslateMessage,ADDR msg
	  invoke DispatchMessage, ADDR msg
	@@:
	  invoke GetMessage,ADDR msg,NULL,0,0
	  test eax, eax
	  jnz StartLoop
	
	
	mov eax, msg.wParam
	ret
WinMain endp

		WM_MACRO equ 8001
		IDM_START_MACRO equ 1
		IDM_HALT_MACRO equ 2
		IDM_FINISH_MACRO equ 3
		IDM_CONTINUE_MACRO equ 4
		
WndProc Proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL hdc:HDC,
	      ps:PAINTSTRUCT,
	      myRect:RECT,
	      myTempChar:DWORD,
		  myLeftNums:RECT,
		  myLeftLine:RECT,
		  myTopRect:RECT,
		  TopVisibleLine:DWORD,
		  CurrentLine:DWORD, 
		  outPos:DWORD
	mov eax, uMsg
	;-----------------------------
	.if eax == WM_DESTROY		 ; uMsg
	;-----------------------------
		invoke UnregisterHotKey,hWnd,HOTKEY_START
		invoke UnregisterHotKey,hWnd,HOTKEY_TRACK
		invoke UnregisterHotKey,hWnd,HOTKEY_HALT
		
		invoke PostQuitMessage, NULL
		
	;-----------------------------
	.elseif eax == WM_HOTKEY	 ; uMsg
	;-----------------------------
		mov eax, wParam
		.if eax == HOTKEY_HALT
			mov HaltFlag, TRUE
			invoke PostMessage,hWnd,WM_MACRO,IDM_FINISH_MACRO,0 ; stop
		.elseif  eax == HOTKEY_START
			invoke ParseEntireMacro,FALSE, TRUE
			invoke InvalidateRect,hWnd,0,TRUE
			invoke PostMessage,hWnd,WM_MACRO,IDM_START_MACRO,0
		.elseif  eax == HOTKEY_TRACK
		
				invoke EnumDisplaySettings,0,ENUM_CURRENT_SETTINGS, Offset myDevMode
				;mov eax, myDevMode.DEVMODE.dmPelsWidth
				;mov ecx, myDevMode.DEVMODE.dmPelsHeight
				;int 3
		
		
			not MouseFlag
			
		.endif
	;-----------------------------
	.elseif eax == WM_MACRO		 ; uMsg
	;-----------------------------
	
		mov eax, wParam
		.if ax == IDM_HALT_MACRO
		
			mov HaltFlag, TRUE  
			invoke PostMessage,hWnd,WM_MACRO,IDM_FINISH_MACRO,0 ; stop

		.elseif ax == IDM_CONTINUE_MACRO
		
			.if  HaltFlag==FALSE && WaitFlag==FALSE 
				invoke RunMacro
				mov eax, NextLine
				mov ecx, OpcodeLineCount
				.if eax<ecx
					invoke PostMessage,hWnd,WM_MACRO,IDM_CONTINUE_MACRO,0 ; continue
				.else
					invoke PostMessage,hWnd,WM_MACRO,IDM_FINISH_MACRO,0 ; stop
				.endif
			.endif
			
		.elseif ax == IDM_FINISH_MACRO
				
				mov WaitFlag, FALSE
				mov HaltFlag, TRUE
				invoke KillTimer,hWnd, IDT_TIMER1
				invoke DestructMacro
	 			invoke SendMessage,hMainEdit ,WM_ENABLE,TRUE,0
	 			invoke SendMessage,hMainEdit,EM_SETREADONLY,FALSE,0
	 			
	 			
		.elseif ax == IDM_START_MACRO
		
		
		
				mov WaitFlag, FALSE        
				mov HaltFlag, FALSE    
				mov NextLine, 0  
				
	 			invoke SendMessage,hMainEdit, WM_ENABLE,FALSE,0
	 			invoke SendMessage,hMainEdit, EM_SETREADONLY,TRUE,0
	 			
				invoke RedrawWindow,hWnd,0,0,RDW_INVALIDATE or RDW_ERASENOW or RDW_UPDATENOW
				
				
			;-------------------------------------
			;   
			;-------------------------------------
				invoke EnumDisplaySettings,0,ENUM_CURRENT_SETTINGS, Offset myDevMode
				;mov eax, myDevMode.DEVMODE.dmPelsWidth
				;mov ecx, myDevMode.DEVMODE.dmPelsHeight
				;int 3
				
				invoke PostMessage,hWnd, WM_MACRO, IDM_CONTINUE_MACRO,0
				
		.endif
		
	;----------------------------;;;;;;;;
	.elseif eax == WM_COMMAND	 ; uMsg ;
	;----------------------------;;;;;;;;
	
		mov eax,wParam
		.if ax==IDM_FILE_NEW
			invoke MessageBox, NULL, ADDR szFileNew, Offset szAppName, MB_OK
		.elseif ax==IDM_FILE_OPEN
			invoke MessageBox, NULL, ADDR szFileOpen, Offset szAppName, MB_OK
			
		.elseif ax==IDM_HELP_ABOUT
			invoke DialogBoxParam,hInstance, DLG_Help, hWnd, Offset HelpDlgProc,NULL
		.elseif ax==IDM_MOUSE_TRACKER
			invoke DialogBoxParam,hInstance, DLG_MouseTracker, 0, Offset MouseTrackerProc, NULL
		.elseif ax==IDM_KEY_TRACKER
			invoke CreateWindowEx,WS_EX_CLIENTEDGE , ADDR KeyTrackerClassName, $String("Key Tracker"),  WS_OVERLAPPEDWINDOW or WS_VISIBLE, CW_USEDEFAULT,CW_USEDEFAULT,200,100, hWnd, NULL,hInstance,NULL 
			mov myKeyTrackerWindow,eax
			;invoke DialogBoxParam,hInstance, DLG_KeyTracker,hWnd, Offset KeyTrackerProc,NULL
		.elseif ax == IDC_MainEdit
		
			mov ax, word ptr wParam+2
			.if ax == EN_VSCROLL
				invoke InvalidateRect,hWnd, ADDR rLeftNums,TRUE
			.endif
			
		.elseif ax == IDM_MACRO_ERRORCHECK
	
			invoke ParseEntireMacro,TRUE, TRUE
			invoke InvalidateRect,hWnd,ADDR rLeftNums,TRUE
			
		.else
			invoke DestroyWindow, hWnd
		.endIf
		
	;-----------------------------
	.elseif eax == WM_TIMER		 ; uMsg
	;-----------------------------
		.if HaltFlag == FALSE && WaitFlag==TRUE
			mov eax, wParam
	 		.if AX==IDT_TIMER1
	 			mov WaitFlag, FALSE
				invoke KillTimer,hWnd, IDT_TIMER1
				invoke PostMessage,hWnd,WM_MACRO,IDM_CONTINUE_MACRO,NextLine ; continue
	 		.endif
	 	.else
			invoke KillTimer,hWnd, IDT_TIMER1
 		.endif
	;-----------------------------
	.elseif eax == WM_VSCROLL	 ; uMsg
	;-----------------------------
	
				invoke InvalidateRect,hWnd,ADDR rLeftNums,TRUE
				
	;-----------------------------
	.elseif eax == WM_CTLCOLOREDIT  ; uMsg
	;-----------------------------
	
			mov eax, lParam
			.if eax==hMainEdit
			
			;-----------------------------
			; Parse Entire Screen
			;-----------------------------
				invoke SendMessage,hMainEdit,EM_GETFIRSTVISIBLELINE,0,0
				invoke ParseMacro,FALSE, FALSE, eax, 40
				
			;-----------------------------
			; Parse Current Line (For Error string)
			;-----------------------------
				invoke SendMessage,hMainEdit,EM_GETSEL,ADDR outPos,0
				invoke SendMessage,hMainEdit,EM_LINEFROMCHAR,outPos,0
				invoke ParseMacro, FALSE, FALSE, eax, 1
				invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  eax
				
				invoke InvalidateRect,hWnd,ADDR rLeftNums,TRUE
				
			.endif
				
	;-----------------------------
	.elseif eax == WM_ERASEBKGND	 ; uMsg
	;-----------------------------
		mov eax, 1
	;-----------------------------
	.elseif eax == WM_PAINT	 ; uMsg
	;-----------------------------
			invoke SendMessage,hMainEdit,EM_GETFIRSTVISIBLELINE,0,0
			mov TopVisibleLine, eax
			mov CurrentLine, eax
			;---------------------------------
			;  BeginPaint
			;---------------------------------
			
			invoke BeginPaint,hWnd, ADDR ps
			mov    hdc,eax
			
				;---------------------------------
				;  Paint Top of screen
				;---------------------------------
				
					
				    invoke SetTextColor,hdc, 0
				    invoke SetBkMode,hdc, TRANSPARENT
								
					invoke GetClientRect,hWnd,ADDR myTopRect
					mov myTopRect.RECT.bottom, TOP_ROW_HEIGHT
					
				    
					invoke SelectObject,hdc, hf14
					push eax
					invoke FillRect,hdc, ADDR myTopRect, 4
				    invoke DrawText, hdc, $String(" Press F7 to Start Macro"), -1, ADDR myTopRect, DT_SINGLELINE or DT_LEFT or DT_VCENTER
				    invoke DrawText, hdc, $String("Press F9 to Halt Macro "), -1, ADDR myTopRect, DT_SINGLELINE or DT_RIGHT or DT_VCENTER
				    pop eax
				    invoke SelectObject,hdc,eax
				    
					
					
				;---------------------------------
				;  Paint background to linenumbers and start
				;---------------------------------
					
					;invoke FillRect,hdc, ADDR rLeftNums, 0
				    invoke SetBkMode,hdc, OPAQUE 
				    ;invoke SetTextColor,hdc, 0
				    
				;---------------------------------
				;  Setup boxes
				;---------------------------------
				
				; myLeftLine = Current number line box
				; myLeftNums = Entire number column
				
					mov eax, rLeftNums.RECT.bottom
					;btr eax, 31
					;adc eax, 0
					;add eax, 16
					
					mov myLeftNums.RECT.bottom, eax
					
					mov eax, rLeftNums.RECT.left
					mov myLeftNums.RECT.left, eax
					mov myLeftLine.RECT.left, eax
					
					mov eax, rLeftNums.RECT.right
					mov myLeftNums.RECT.right, eax
					mov myLeftLine.RECT.right, eax
					
					mov eax, rLeftNums.RECT.top
					mov myLeftNums.RECT.top, eax
					mov myLeftLine.RECT.top, eax
					
					add eax, 16
					mov myLeftLine.RECT.bottom, eax
					
					
					invoke CreateRectRgnIndirect, addr myLeftNums
					push eax
					
					
				    invoke SelectClipRgn,hdc,eax 
				    
				;---------------------------------
				; For i=scrolltop to scrollbottom
				;---------------------------------
				
				repeatscroll:
					;---------------------------------
					; FLAGGED?
					;---------------------------------
					
					mov eax, CurrentLine
					.if eax < OpcodeLineCount
						shl eax, 4
						.if dword ptr MicroCode[eax]== KW_FLAG_SYNTAX
							;;Syntax Error
							invoke SetBkColor,hdc, 000FFFFh ; YELLOW
						.elseif dword ptr MicroCode[eax]== KW_FLAG_RUNTIME
							;;Runtime Error
							invoke SetBkColor,hdc, 00000FFh ; RED
						.elseif dword ptr MicroCode[eax]== KW_FLAG_BLANK
							;;Blank Line
							invoke SetBkColor,hdc, 0EEEEEEh ; LIGHT GRAY
					   	.else
						   	;;No Error
						   	invoke SetBkColor,hdc, 000FF00h ; GREEN
					   	.endif
					.else
						;;Not a line
						invoke SetBkColor,hdc, 0FFFFFFh ; WHITE
					.endif
					    
				    
					
					invoke DWItoDWA, CurrentLine
					mov dword ptr myTempChar, eax
					invoke FillRect,hdc, ADDR myLeftLine, 3
					invoke DrawText, hdc, ADDR myTempChar, 4, ADDR myLeftLine,  DT_CENTER
					add CurrentLine, 1
					
				;----------------------------------------------------------
				; Bump the "myLeftLine" box down, until its all the way
				;----------------------------------------------------------
				
					add myLeftLine.RECT.top, 16
					add myLeftLine.RECT.bottom, 16
					
					mov eax, myLeftLine.RECT.bottom
					cmp myLeftNums.RECT.bottom, eax
					
					ja repeatscroll
		
		
			pop eax
			invoke DeleteObject,eax
			
			invoke EndPaint,hWnd, ADDR ps
			
	;-----------------------------
	.elseif eax== WM_CREATE	 ; uMsg
	;-----------------------------
		;invoke GetSystemMetrics,SM_CXSCREEN
		;mov ResolutionX, eax
		;invoke GetSystemMetrics,SM_CYSCREEN
		;mov ResolutionY, eax

		mov myDevMode.DEVMODE.dmFields, 0
		mov myDevMode.DEVMODE.dmSize, Sizeof DEVMODE
		mov myDevMode.DEVMODE.dmDriverExtra, 0 
		invoke EnumDisplaySettings,0,ENUM_CURRENT_SETTINGS, Offset myDevMode

		invoke RegisterHotKey,hWnd,HOTKEY_START,0,VK_F7
		invoke RegisterHotKey,hWnd,HOTKEY_TRACK,0,VK_F8
		invoke RegisterHotKey,hWnd,HOTKEY_HALT,0,VK_F9
		
		
	;-----------------------------
	.elseif eax== WM_SHOWWINDOW	 ; uMsg
	;-----------------------------
	
	
	;-----------------------------
	.elseif eax==WM_SIZE		 ; uMsg
	;-----------------------------
		;@@ get size info
		movzx eax, word ptr lParam   ; << width
		movzx ecx, word ptr lParam+2 ; << height
		mov rLeftNums.RECT.bottom, ecx
		
		sub eax, LEFT_COLUMN_WIDTH
		sub ecx, TOP_ROW_HEIGHT+17 ; (adjust for statusbar) 
		
		invoke MoveWindow,hMainEdit,LEFT_COLUMN_WIDTH,40,eax,ecx,TRUE
		
		movzx eax, word ptr lParam
		sub eax, 210
		invoke MoveWindow,hLabel2,eax,5,200,20,TRUE
	  	invoke MoveWindow,hStatusBar,0,0,0,0,TRUE
	  	
	;-----------------------------
	.else						 ; uMsg
	;-----------------------------
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
	.endIf
	xor eax,eax
	ret
WndProc EndP

.data

align 4
KeyTrackIDec db '10:'
KeyTrackODec dd 0
KeyTrackIHex db '16:'
KeyTrackOHex dd 0 
KeyTrackChar db 0

.code
KeyTrackerProc PROC hWnd:HWND,uMsg:DWORD,wParam:WPARAM, lParam:LPARAM
LOCAL keyRect:RECT,
	  ps:PAINTSTRUCT,
	  hdc:HDC

	mov eax, uMsg
	;-----------------------------
	.if eax==WM_KEYDOWN
	;-----------------------------
	
		mov eax, wParam
		mov KeyTrackChar, al
		invoke GetClientRect,hWnd,ADDR keyRect
		invoke InvalidateRect,hWnd,ADDR keyRect,TRUE
		
	;-----------------------------
	.elseif eax==WM_CREATE
	;-----------------------------
		invoke EnableWindow, hwnd, FALSE
	;-----------------------------
	.elseif eax==WM_DESTROY
	;-----------------------------
		
		invoke EnableWindow, hwnd, TRUE
	;-----------------------------
	.elseif eax==WM_ERASEBKGND
	;-----------------------------
	;-----------------------------
	.elseif eax==WM_PAINT
	;-----------------------------
	
		invoke BeginPaint,hWnd,ADDR ps
		mov hdc, eax
		
			movzx eax, KeyTrackChar
			invoke DWItoDWA, eax
			mov KeyTrackODec, eax
			
			movzx eax, KeyTrackChar
			invoke DWItoDWH, eax
			mov KeyTrackOHex, eax
			
			
			
			invoke GetClientRect,hWnd,ADDR keyRect
			invoke GetStockObject,GRAY_BRUSH
			invoke FillRect,hdc,ADDR keyRect, eax
		    invoke SetBkMode,hdc, TRANSPARENT
		    invoke SetTextColor,hdc, 0
		    
		    
		    
					invoke SelectObject,hdc, hfGetKey
					push eax
					sub keyRect.top, 12
				    sub keyRect.bottom, 12
				    invoke DrawText, hdc,Offset KeyTrackIDec, 7, ADDR keyRect,  DT_SINGLELINE or DT_LEFT or DT_VCENTER or DT_CENTER
				    add keyRect.top, 24
				    add keyRect.bottom, 24
				    invoke DrawText, hdc,Offset KeyTrackIHex, 7, ADDR keyRect,  DT_SINGLELINE or DT_LEFT or DT_VCENTER or DT_CENTER
				    pop eax
				    invoke SelectObject,hdc,eax
				    
			
		invoke EndPaint,hWnd,ADDR ps
		
	;-----------------------------
	.else
	;-----------------------------
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
	.endif
	
	xor eax,eax
	ret
KeyTrackerProc endp


.data
MouseFlag BOOL not 0
myBrush LOGBRUSH < BS_SOLID, 0FF00FFh, 0>

hBrushColor		HBRUSH	?
hBrushInvert	HBRUSH	?

rectStaticColor  RECT <?,?,?,?>
rectStaticInvert RECT <?,?,?,?>

hStaticColor  HANDLE ?
hStaticInvert HANDLE ?

colorStaticColor COLORREF ?
colorStaticInvert COLORREF ?

lalarect RECT <5,50,60,70>
.code
MouseTrackerProc PROC hWnd:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM
LOCAL thePos:QWORD,
	  mickeyPos:QWORD
	.if iMsg==WM_INITDIALOG
		invoke EnumDisplaySettings,0,ENUM_CURRENT_SETTINGS, Offset myDevMode
		mov MouseFlag,0
		
		invoke SetTimer,hWnd, IDT_TIMER_MOUSETRACK,50,0
		invoke GetWindowDC,0
		mov hDC, eax
		
		
		invoke GetDlgItem,hWnd,IDC_STATIC_COLOR
		mov hStaticColor, eax
		invoke GetClientRect,eax,Offset rectStaticColor		
		
		invoke GetDlgItem,hWnd,IDC_STATIC_INVERT
		mov hStaticInvert, eax
		invoke GetClientRect,eax,Offset rectStaticInvert	
		
		not MouseFlag 
	.elseif iMsg== WM_TIMER
	
		;-------------------------------
		; Only do this if we need it
		;-------------------------------
			cmp MouseFlag, 0
			je SameAsOld
				invoke EnumDisplaySettings,0,ENUM_CURRENT_SETTINGS, Offset myDevMode
		
		;-------------------------------
		; Get the mouse cursor location
		;-------------------------------
			invoke GetCursorPos,addr thePos
			mov ecx, dword ptr [thePos+4]
			mov eax, dword ptr [thePos]
			mov dword ptr [mickeyPos+4], ecx
			mov dword ptr [mickeyPos], eax
			
		;-------------------------------
		; Don't bother with coordinates if the mouse hasn't moved
		;-------------------------------
		
			cmp dword ptr [qwOldPos+4], ecx
			jne NotSameAsOld
			
			cmp dword ptr [qwOldPos], eax
			je SameAsOld
			
		;-------------------------------
		; Update qwOldPos
		;-------------------------------
			NotSameAsOld:
			mov dword ptr [qwOldPos+4], ecx
			mov dword ptr [qwOldPos], eax
		
		;-------------------------------
		; Calculate cursor in 16 bit scale
		;-------------------------------
			invoke PixelsToMickeys, addr mickeyPos
			invoke SetDlgItemInt,hWnd,IDC_EDIT_X,word ptr [mickeyPos],0
			invoke SetDlgItemInt,hWnd,IDC_EDIT_Y,word ptr [mickeyPos+4],0
		
		;-------------------------------
		; Get pixel colors
		;-------------------------------
		
			movzx eax, word ptr [thePos]
			movzx ecx, word ptr [thePos+4]
			invoke GetPixel,hDC,eax,ecx
			mov colorStaticColor, eax
			not eax
			mov colorStaticInvert, eax
			
		;-------------------------------
		; Convert to text
		;-------------------------------
			
			invoke DWItoQWH, colorStaticColor
			movq qword ptr [szTempHexColor], mm0
			mov byte ptr [szTempHexColor+9],0
			invoke SetDlgItemText,hWnd,IDC_EDIT_COLOR,offset szTempHexColor
			
			invoke DWItoQWH, colorStaticInvert
			movq qword ptr [szTempHexColor], mm0
			mov byte ptr [szTempHexColor+9],0
			invoke SetDlgItemText,hWnd,IDC_EDIT_INVERT,offset szTempHexColor
			
		;-------------------------------
		; Display colors
		;-------------------------------
			invoke InvalidateRect,hStaticColor,Offset rectStaticColor,TRUE
			invoke InvalidateRect,hStaticInvert,Offset rectStaticInvert,TRUE
			
		
		SameAsOld:
		
		
	.elseif iMsg==WM_CTLCOLORSTATIC
		mov eax, lParam
  		 .if eax==hStaticColor
  		 
	  		 invoke DeleteObject, hBrushColor
	  		 mov eax, colorStaticColor
	  		 mov myBrush.LOGBRUSH.lbColor, eax
	  		 invoke CreateBrushIndirect, Offset myBrush
	  		 mov hBrushColor, eax
	  		 
  		 .elseif eax==hStaticInvert
  		 
	  		 invoke DeleteObject, hBrushInvert
	  		 mov eax, colorStaticInvert
	  		 mov myBrush.LOGBRUSH.lbColor, eax
	  		 invoke CreateBrushIndirect, Offset myBrush
	  		 mov hBrushInvert, eax
  		 
  		 .endif
  		 
  		 ret
	.elseif iMsg==WM_COMMAND
		mov eax, wParam
		.if ax==IDC_PAUSEBUTTON
			not MouseFlag
		.endif
	.elseif iMsg==WM_CLOSE
		invoke KillTimer,hwnd, IDT_TIMER_MOUSETRACK
		invoke ReleaseDC,0,hDC
		invoke EndDialog,hWnd,NULL
	.else
		mov eax,FALSE
		ret
	.endif
	
	mov  eax,TRUE
	ret
MouseTrackerProc endp

HelpDlgProc PROC hWnd:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM

	.if iMsg==WM_INITDIALOG
	
	.elseif iMsg==WM_CLOSE
		invoke EndDialog,hWnd,NULL
	.else
		mov  eax,FALSE
		ret
	.endif
	
	mov  eax,TRUE
	ret
		
HelpDlgProc ENDP


		;------------------------------------------------------------------
		;
		;------------------------------------------------------------------
ParseEntireMacro PROC DisplayErrors:BOOL, LeakString:BOOL
	invoke ParseMacro,DisplayErrors,LeakString,0,30000
	ret
ParseEntireMacro ENDP


.code
ParseMacro PROC uses edi esi ebx DisplayErrors:BOOL, LeakString:BOOL, StartLine:DWORD, NumLines:DWORD
 LOCAL	Param3:DWORD,Param2:DWORD,Param1:DWORD,Instruction:DWORD, 
 		KeywordSize:DWORD,
 		LiteralSize:DWORD,pLiteral:DWORD,
		ErrorCount:DWORD, 
		myLineLength:DWORD,
		myLineStr:DWORD,
		NumLinesChecked:DWORD,
		CurrentLineIndex:DWORD,
		LastLineIndex:DWORD,
		KeywordIsSuccessfulString:BOOL
		
		mov KeywordIsSuccessfulString, 0
		mov NumLinesChecked, 0
		mov CurrentErrorMessage, Offset NoErrorMessage
		mov ContinueErrorFlag, IDOK
		;------------------------------------------------------------------
		; Setup data
		;------------------------------------------------------------------
		
	
			mov ErrorCount, 0
			
			mov eax, StartLine
			mov CurrentLineIndex, eax
			
			add eax, NumLines
			sub eax, 1
			mov LastLineIndex, eax
			
			cmp NumLines, 0
			je ParsingDone
			
		;------------------------------------------------------------------
		; Make sure LastLine isn't out of range
		;------------------------------------------------------------------
			invoke SendMessage,hMainEdit, EM_GETLINECOUNT, 0, 0
			mov OpcodeLineCount, eax
			sub eax, 1
			cmp LastLineIndex,eax
			jbe @F
				mov LastLineIndex, eax
			@@:
			
		;------------------------------------------------------------------
		; Line loop
		;------------------------------------------------------------------
			
				
			;------------------------------------------------------------------
			; Dummy alloc 
			;------------------------------------------------------------------
			invoke HeapAlloc,hHeap,0, 4
			mov myLineStr, eax
			
		 StartOnNextLine:
		 
	  		add NumLinesChecked, 1
		 
		 
			;------------------------------------------------------------------
			; Copy line / set to ESI / null terminate
			;------------------------------------------------------------------
			
			;=========================================================
			;                <HeapFree>
			;=========================================================
			
				; Keep string if we had a successful string keyword 
				mov eax, LeakString
				and eax, KeywordIsSuccessfulString
				.if eax==0
					invoke HeapFree,hHeap,0, myLineStr
				.endif
				mov KeywordIsSuccessfulString, 0
				
			;=========================================================
			;                <HeapFree>
			;=========================================================
				
				invoke SendMessage, hMainEdit, EM_LINEINDEX, CurrentLineIndex, 0
				invoke SendMessage, hMainEdit, EM_LINELENGTH, eax, 0
				mov myLineLength, eax
				add eax, 1
				invoke HeapAlloc,hHeap,0, eax
				mov myLineStr, eax
				mov esi, eax
					
				;-----------------
				;  For EM_GETLINE
				;-----------------
					mov eax, myLineLength
					add eax, 1
					mov word ptr [esi], ax
					
				invoke SendMessage, hMainEdit, EM_GETLINE, CurrentLineIndex,  esi
				mov ecx, myLineLength
				mov byte ptr [esi+ecx], 0
				
				 xor eax, eax
				 xor ebx, ebx	; char index
				 xor ecx, ecx	; char index
				 mov edx, kwTotal ; word index
				 mov edi, Offset szKeywords
			 
	;------------------------------------------------------------------
	; Compare text with keyword list (szBufferText[ecx] == szKeyword[edx])
	;------------------------------------------------------------------

;=========================================================
;                  LOOP KEYWORDS
;=========================================================

		NewKeyword:
			
		;------------------------------------------------------------------
		; Loop through keywords, fail if none match
		;------------------------------------------------------------------
				
			sub edx,1
			.if CARRY?
				mov Instruction, KW_FLAG_SYNTAX
				mov CurrentErrorMessage, Offset Error_InvalidKeyword
				add ErrorCount, 1
				.if DisplayErrors!=0
					invoke DisplayError,CurrentLineIndex,Offset Error_InvalidKeyword
				.endif
				jmp DoneWithLine
			.endif
			xor ecx, ecx
			
		;------------------------------------------------------------------
		; Are we done with the line?
		;------------------------------------------------------------------
		
			.if byte ptr [esi] == 0
				mov Instruction, KW_FLAG_BLANK
				jmp DoneWithLine
			.endif
			
	;=========================================================
	;                  KEYWORD LOOP LETTERS
	;=========================================================

		NewLetter:
		
		;------------------------------------------------------------------
		; Begin new letter
		;------------------------------------------------------------------
			add ecx, 1
			add ebx, 1
			mov al, [edi+ebx-1]  ; take letter from keyword
	
		;------------------------------------------------------------------
		; If we've compare all letters and reach null, then the keyword matches.
		;------------------------------------------------------------------
						
			test al,al
			jz KeywordSuccess
			 
		;------------------------------------------------------------------
		; Otherwise, make sure the letter matches.
		;------------------------------------------------------------------
						
		    cmp al, [esi+ecx-1] ; compare it to letter
		  	je NewLetter
					  	 
		;------------------------------------------------------------------
		; The letter didn't match.  Seek null for next keyword.
		;------------------------------------------------------------------
	
			@@:
				add ebx, 1
				cmp byte ptr [edi+ebx-2], 0 ; is zero?
				jne @B
				
				sub ebx,1
		
		;------------------------------------------------------------------
		; The keyword didn't match, try the next keyword
		;------------------------------------------------------------------
					   
		  jmp NewKeyword
			  
				
KeywordSuccess:
  add esi, ecx
  mov Instruction, edx
  mov KeywordSize, ecx

;=========================================================
;                   PARAMETER TESTING 
;=========================================================

  				
		;------------------------------------------------------------------
  		;  Be forgiving and allow for spaces
		;------------------------------------------------------------------
			sub esi,1
			@@:
				add esi,1
				cmp byte ptr [esi-1], 0 ; EndOfLine error
				je ErrorSemicolon
				cmp byte ptr [esi-1], " "
				je @B
				
		;------------------------------------------------------------------
  		;  Test if it's a Quote or a Number or a Literal
		;------------------------------------------------------------------
		  cmp byte ptr [esi-1],';'
		  je DoneWithParameters
		  cmp byte ptr [esi-1], "'" 
		  je ParameterIsQuote
		  cmp byte ptr [esi-1],'9'
		  ja ParameterIsLiteral
		  cmp byte ptr [esi-1],'0'
		  jb ParameterIsLiteral 
		
		jmp ParameterIsNumber
		ParameterIsQuote:  
	;=========================================================
	;                   QUOTE
	;=========================================================
	  
		;------------------------------------------------------------------
  		;  It's a quote, so adjust the instruction opcode
		;------------------------------------------------------------------
			
			not Instruction ; Make it a string-type keyword
			push myLineStr
			pop Param1     ; Param1 Contains the pointer to the beginning of the line (the alloc)
			mov Param2,esi ; Param1 Contains the pointer to the string param
			
		;------------------------------------------------------------------
  		;  SEARCH FOR ENDQUOTE          ; esi -> after the start quote
		;------------------------------------------------------------------
		;@@@@ TODO ?
				;cmp byte ptr [esi], 0 ; EndOfLine error
				;je ErrorQuote
				
			@@:
				add esi,1
				cmp byte ptr [esi], 0 ; EndOfLine error
				je ErrorQuote
				cmp byte ptr [esi], "'"
				jne @B
		
		;------------------------------------------------------------------
		; This is to display an error if there was only one quote mark
		;------------------------------------------------------------------
		
			jmp @F
				ErrorQuote:
				mov Instruction, KW_FLAG_SYNTAX
				mov CurrentErrorMessage, Offset Error_NoSecondQuoteMark
				add ErrorCount, 1
				.if DisplayErrors!=0
					invoke DisplayError, CurrentLineIndex, Offset Error_NoSecondQuoteMark
				.endif
				jmp DoneWithLine
			@@:
			
		;------------------------------------------------------------------
		; Done with ENDQUOTE
		;------------------------------------------------------------------

		
		add esi,1
		; esi = after the endquote
		mov KeywordIsSuccessfulString, TRUE
	
  jmp SkipParamsForString
	  
	;=========================================================
	;                  </QUOTE>
	;=========================================================
	
		ParameterIsLiteral:
	
	;=========================================================
	;                  <LITERAL> ; TODO::::::: DEBUG/TEST 
	;=========================================================
		
		    mov pLiteral, esi
		    sub pLiteral,1
		    
		;------------------------------------------------------------------
  		;  SEARCH FOR NONALPHA          esi -> first char
		;------------------------------------------------------------------
		mov eax, pLiteral
			xor ecx, ecx
			@@:
				add esi, 1
				add ecx, 1
				cmp byte ptr [esi],'z'
				ja @F
				cmp byte ptr [esi],'A'
				jae @B
				@@:
			mov LiteralSize, ecx
			
			
			
		
		;------------------------------------------
		; Don't bother if it's only a syntax check
		;------------------------------------------
		 .if LeakString!=0
		 
			;-----------------------------
			; Make ITEM
			;-----------------------------
				invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY, Sizeof ITEM
				mov ebx, eax
				
				;-----------------------------
				; Name
				;-----------------------------
					mov eax, LiteralSize
					mov [ebx].ITEM.dwNameLength, eax
					invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,eax
					mov [ebx].ITEM.pName, eax
				;-----------------------------
				; !!!!! Copy Literal string to [eax]
				;-----------------------------
					invoke szCopyx,pLiteral,eax,LiteralSize
				;-------------------------------------
				; Auto-get pItem from global LList
				;-------------------------------------
					mov Param1, ebx
					invoke GetItemFromList, ebx
					
		 .endif
		 
  jmp SkipParamsForLiteral
		 
	;=========================================================
	;                  </LITERAL>
	;=========================================================
	
		ParameterIsNumber:
	
	;=========================================================
	;                  <NUMBER>
	;=========================================================
		 
	;------------------------------------------------------------------
	; Param1
	;------------------------------------------------------------------
	sub esi,1
	
		;------------------------------------------------------------------
		; Get number as integer
		;------------------------------------------------------------------
			
				
			invoke atoi, esi
			mov esi, edx   ; edx -> character after numstr
			mov Param1, eax ; eax == value
			
	SkipParamsForLiteral:
		;------------------------------------------------------------------
  		;  Be forgiving and allow for spaces
		;------------------------------------------------------------------
			sub esi,1
			@@:
				add esi,1
				cmp byte ptr [esi], ';' ; Done
				je DoneWithParameters
				cmp byte ptr [esi], 0 ; Semicolon error
				je ErrorSemicolon
				cmp byte ptr [esi], " " ; Seek
				je @B
		;------------------------------------------------------------------
		; Next parameter?
		;------------------------------------------------------------------
	
			  mov cl, byte ptr [esi]
			  cmp cl, ','
			  jne DoneWithParameters
  
				
	;------------------------------------------------------------------
	; Param2
	;------------------------------------------------------------------
		;------------------------------------------------------------------
  		;  Be forgiving and allow for spaces
		;------------------------------------------------------------------
			@@:
				add esi,1
				cmp byte ptr [esi], ';' ; Done
				je DoneWithParameters
				cmp byte ptr [esi], 0 ; Semicolon error
				je ErrorSemicolon
				cmp byte ptr [esi], " " ; Seek
				je @B
		;------------------------------------------------------------------
		; Get number as integer
		;------------------------------------------------------------------
			
			invoke atoi, esi
			mov esi, edx
			mov Param2, eax
  
SkipParamsForString:
  
				
		;------------------------------------------------------------------
		; Next parameter?
		;------------------------------------------------------------------
		
			cmp byte ptr [esi], ','
			jne DoneWithParameters
  
	;------------------------------------------------------------------
	; Param3
	;------------------------------------------------------------------
	add esi,1
	
		;------------------------------------------------------------------
		; Get number as integer
		;------------------------------------------------------------------
		
		  invoke atoi, esi
		  mov esi, edx
		  mov Param3, eax 
		     

;=========================================================
;                 </NUMBER>
;=========================================================

DoneWithParameters:

;=========================================================
;                <SEMICOLON>
;=========================================================

	;------------------------------------------------------------------
	;  Be forgiving and allow for spaces
	;------------------------------------------------------------------
		sub esi,1
		@@:
			add esi,1
			cmp byte ptr [esi], 0 ; Semicolon error
			je ErrorSemicolon
			cmp byte ptr [esi], " " ; Seek
			je @B
			
	;------------------------------------------------------------------
	; ErrorSemicolon
	;------------------------------------------------------------------
				
		cmp byte ptr [esi], ';'
		je @F
			ErrorSemicolon:
			mov Instruction, KW_FLAG_SYNTAX
			mov KeywordIsSuccessfulString, 0
			mov CurrentErrorMessage, Offset Error_NoSemiColon
			add ErrorCount, 1
			.if DisplayErrors!=0
				invoke DisplayError, CurrentLineIndex, Offset Error_NoSemiColon
			.endif
		@@:
		
;=========================================================
;                </SEMICOLON>
;=========================================================

DoneWithLine:
 
;=========================================================
;                <LOADMICROCODE>
;=========================================================

  
	  mov ecx, offset MicroCode
	  mov eax, CurrentLineIndex
	  shl eax, 4
	  lea ecx, [ecx+eax]   ; <- points to current micro op
	  
	  push Param3
	  push Param2
	  push Param1
	  push Instruction
	  pop dword ptr [ecx]	    ; Instruction:DWORD
	  pop dword ptr [ecx+4]		; Param1 : DWORD
	  pop dword ptr [ecx+8]		; Param2 : DWORD
	  pop dword ptr [ecx+12]	; Param3 : DWORD
	  
	  add CurrentLineIndex, 1
	  
	  
	  ;------------------------------
	  ; Bound Check
	  ;------------------------------
		
		mov eax, CurrentLineIndex
		cmp eax, LastLineIndex
		ja ParsingDone
		  
	  
  jmp StartOnNextLine
  
;=========================================================
;                </LOADMICROCODE>
;=========================================================

 
 ParsingDone:
 

;=========================================================
;                <DISPLAYERRORS>
;=========================================================

 	.if DisplayErrors!=0
 		
 		invoke itoa,ErrorCount,Offset ErrorCountStringNumber
		invoke MessageBox,hwnd,Offset ErrorCountString,$String("Error check finished."),MB_OK
	
	.endif
	
;=========================================================
;                </DISPLAYERRORS>
;=========================================================
		
;=========================================================
;                <HeapFree>
;=========================================================

	; Keep string if we had a successful string keyword 
	mov eax, LeakString
	and eax, KeywordIsSuccessfulString
	.if eax==0
		invoke HeapFree,hHeap,0, myLineStr
	.endif
;=========================================================
;                <HeapFree>
;=========================================================
	
	
	
	
	mov eax, CurrentErrorMessage
	
 ret
ParseMacro EndP






RunMacro PROC uses esi edi ebx
 LOCAL CurrentLine:DWORD,
 	   Param3:DWORD,
 	   Param2:DWORD,
 	   Param1:DWORD,
 	   Instruction:DWORD,
 	   ShiftIsPressed:BOOL
 
  mov ebx, NextLine 	; Get line
  mov esi, offset MicroCode
  mov CurrentLine, ebx  ; Store temp current
  add NextLine, 1  		; Update next line
  shl ebx, 4
  
  push dword ptr [esi+ebx]
  push dword ptr [esi+ebx+4]
  push dword ptr [esi+ebx+8]
  push dword ptr [esi+ebx+12]
  pop Param3
  pop Param2
  pop Param1
  pop Instruction
 
 
			
 	mov edx, Instruction
	.if edx==KW_MOVE_INT
	
		;movzx eax, Param1
		;movzx ecx, Param2
		;invoke mouse_event,MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_MOVE,eax,ecx,0,0
		
		mov eax, Param1
		mov ecx, Param2
		mov MYMOUSEINPUT.dwX, eax	
		mov MYMOUSEINPUT.dwY, ecx	
		
		mov MYMOUSEINPUT.dwFlags, MOUSEEVENTF_MOVE or MOUSEEVENTF_ABSOLUTE
		invoke SendInput,1,Offset MYMOUSEINPUT, 28
		
	.elseif edx==KW_DELTA_INT
	
		mov eax, Param1
		mov ecx, Param2
		mov MYMOUSEINPUT.dwX, eax	
		mov MYMOUSEINPUT.dwY, ecx	
		
		mov MYMOUSEINPUT.dwFlags, MOUSEEVENTF_MOVE
		invoke SendInput,1,Offset MYMOUSEINPUT, 28
						
	.elseif edx==KW_CLICK_INT
	
	
		;MOUSEEVENTF_LEFTDOWN                 equ 00000010 = 2 (bit#1)  
		;MOUSEEVENTF_LEFTUP                   equ 00000100 = 4
		;MOUSEEVENTF_RIGHTDOWN                equ 00001000 = 8 (bit#3)
		;MOUSEEVENTF_RIGHTUP                  equ 00010000 = 16
		;MOUSEEVENTF_MIDDLEDOWN               equ 00100000 = 32 (bit#5)
		;MOUSEEVENTF_MIDDLEUP                 equ 01000000 = 64
		
			xor eax, eax
			mov ecx, Param1
			shl ecx, 1   ; (0,1,2) -> (0,2,4)
			add ecx,1    ; (0,2,4) -> {1,3,5}
			bts eax, ecx ; {1,3,5} -> {2,8,32}
    	;------------------------------------------
		; Button down = Left/Right/Middle :: 0/1/2
    	;------------------------------------------
			mov MYMOUSEINPUT.dwFlags, eax
			invoke SendInput,1,Offset MYMOUSEINPUT, 28
    	;------------------------------------------
		; Button up = same thing shifted left once
    	;------------------------------------------
    	 	shl MYMOUSEINPUT.dwFlags, 1
			invoke SendInput,1,Offset MYMOUSEINPUT, 28
    	 	
	.elseif edx==KW_CLICKDOWN_INT
	
			xor eax, eax
			mov ecx, Param1
			shl ecx, 1 ; (0,1,2) -> (0,2,4)
			add ecx,1  ; (0,2,4) -> {1,3,5}
			bts eax, ecx  ; set bit#ecx
    	 	;invoke mouse_event,eax ,0,0,0,0
    	;------------------------------------------
		; Button down = Left/Right/Middle :: 0/1/2
    	;------------------------------------------
			mov MYMOUSEINPUT.dwFlags, eax
			invoke SendInput,1,Offset MYMOUSEINPUT, 28
			
	.elseif edx==KW_CLICKUP_INT
	
			xor eax, eax
			mov ecx, Param1
			shl ecx, 1 ; (0,1,2) -> (0,2,4)
			add ecx,2  ; (0,2,4) -> {2,4,6}
			bts eax, ecx  ; set bit#ecx
    	 	;invoke mouse_event,eax ,0,0,0,0
    	;------------------------------------------
		; Button up = same thing shifted left once
    	;------------------------------------------
			mov MYMOUSEINPUT.dwFlags, eax
			invoke SendInput,1,Offset MYMOUSEINPUT, 28
    	 	
	.elseif edx== KW_TYPE_INT
	
				mov eax, Param1
				invoke VkKeyScan, eax
				
		    	;------------------------------------------
				; Press shift if necessary
		    	;------------------------------------------
					push eax
					bt eax, 8
					.if CARRY?
						mov ShiftIsPressed, TRUE
						mov MYKEYBINPUT.S_key_INPUT.wVk, VK_SHIFT
						mov MYKEYBINPUT.S_key_INPUT.dwFlags, 0
						invoke SendInput,1,Offset MYKEYBINPUT, 28
					.endif
		    	;------------------------------------------
				; Send VK code
		    	;------------------------------------------
					mov MYKEYBINPUT.S_key_INPUT.wVk, ax
					mov MYKEYBINPUT.S_key_INPUT.dwFlags, 0
					invoke SendInput,1,Offset MYKEYBINPUT, 28
					mov MYKEYBINPUT.S_key_INPUT.dwFlags, KEYEVENTF_KEYUP
					invoke SendInput,1,Offset MYKEYBINPUT, 28
				;------------------------------------------
				; Release shift if necessary
		    	;------------------------------------------
			    	pop eax
					bt eax, 8
					.if CARRY?
						mov MYKEYBINPUT.S_key_INPUT.wVk, VK_SHIFT
						mov MYKEYBINPUT.S_key_INPUT.dwFlags, KEYEVENTF_KEYUP
						invoke SendInput,1,Offset MYKEYBINPUT, 28
					.endif
				
	.elseif edx==KW_KEYDOWN_INT
	
		  		;invoke keybd_event,byte ptr Param1,byte ptr Param3,0,0
	  		
	  			mov eax, Param1
				mov MYKEYBINPUT.S_key_INPUT.wVk, ax
				mov MYKEYBINPUT.S_key_INPUT.dwFlags, 0
				invoke SendInput,1,Offset MYKEYBINPUT, 28
		  		
				
	.elseif edx==KW_KEYUP_INT
	
			;invoke keybd_event,byte ptr Param1,byte ptr Param3,KEYEVENTF_KEYUP,0
			
  			mov eax, Param1
			mov MYKEYBINPUT.S_key_INPUT.wVk, ax
			mov MYKEYBINPUT.S_key_INPUT.dwFlags, KEYEVENTF_KEYUP
			invoke SendInput,1,Offset MYKEYBINPUT, 28
	
	.elseif edx==KW_TYPE_STR ; string to type is at location [Param1:Param2]
	
			mov edi, dword ptr Param2
			
			;------------------------------------------
			; Adjust to beginning of string
			;------------------------------------------
			
		    	mov ShiftIsPressed, FALSE
		    	
			;------------------------------------------
			; SCRAMBLE ASCII INTO VIRTUAL KEYCODE
			;------------------------------------------
			
			@@:
				movzx eax, byte ptr [edi]
				invoke VkKeyScan, eax
				
		    	;------------------------------------------
				; Test for shift
		    	;------------------------------------------
		    	
		    		
		    	
					mov MYKEYBINPUT.S_key_INPUT.dwFlags, 0
					mov MYKEYBINPUT.S_key_INPUT.wVk, VK_SHIFT
					
					push eax
					bt eax, 8
					.if CARRY?
			    	;------------------------------------------
					; Press shift if necessary
			    	;------------------------------------------
						.if ShiftIsPressed==FALSE
							mov ShiftIsPressed, TRUE
							invoke SendInput,1,Offset MYKEYBINPUT, 28
						.endif
					.else
			    	;------------------------------------------
					; Release shift if necessary
			    	;------------------------------------------
						.if ShiftIsPressed!=FALSE
							mov ShiftIsPressed, FALSE
							mov MYKEYBINPUT.S_key_INPUT.dwFlags, KEYEVENTF_KEYUP
							invoke SendInput,1,Offset MYKEYBINPUT, 28
						.endif
					.endif
					pop eax
		    	;------------------------------------------
				; Send VK code
		    	;------------------------------------------
					mov MYKEYBINPUT.S_key_INPUT.wVk, ax
					mov MYKEYBINPUT.S_key_INPUT.dwFlags, 0 
					invoke SendInput,1,Offset MYKEYBINPUT, 28
					mov MYKEYBINPUT.S_key_INPUT.dwFlags, KEYEVENTF_KEYUP
					invoke SendInput,1,Offset MYKEYBINPUT, 28
					
					
					add edi, 1
					cmp byte ptr [edi], "'"
					jne @B
					
		    	;------------------------------------------
				; Release shift if necessary
		    	;------------------------------------------
					.if ShiftIsPressed!=FALSE
						mov MYKEYBINPUT.S_key_INPUT.wVk, VK_SHIFT
						mov MYKEYBINPUT.S_key_INPUT.dwFlags, KEYEVENTF_KEYUP
						invoke SendInput,1,Offset MYKEYBINPUT, 28
					.endif
					
			
	.elseif edx==KW_KEYDOWN_STR
	
			mov edi, dword ptr Param2
			
			;------------------------------------------
			; Adjust to beginning of string
			;------------------------------------------
			
		    	mov ShiftIsPressed, FALSE
		    	
			;------------------------------------------
			; SCRAMBLE ASCII INTO VIRTUAL KEYCODE
			;------------------------------------------
			
			@@:
				movzx eax, byte ptr [edi]
				invoke VkKeyScan, eax
				
		    	;------------------------------------------
				; Test for shift
		    	;------------------------------------------
		    	
		    		
		    	
					mov MYKEYBINPUT.S_key_INPUT.dwFlags, 0
					mov MYKEYBINPUT.S_key_INPUT.wVk, VK_SHIFT
					
					push eax
					bt eax, 8
					.if CARRY?
			    	;------------------------------------------
					; Press shift if necessary
			    	;------------------------------------------
						.if ShiftIsPressed==FALSE
							mov ShiftIsPressed, TRUE
							invoke SendInput,1,Offset MYKEYBINPUT, 28
						.endif
					.else
			    	;------------------------------------------
					; Release shift if necessary
			    	;------------------------------------------
						.if ShiftIsPressed!=FALSE
							mov ShiftIsPressed, FALSE
							mov MYKEYBINPUT.S_key_INPUT.dwFlags, KEYEVENTF_KEYUP
							invoke SendInput,1,Offset MYKEYBINPUT, 28
						.endif
					.endif
					pop eax
		    	;------------------------------------------
				; Send VK code
		    	;------------------------------------------
					mov MYKEYBINPUT.S_key_INPUT.wVk, ax
					mov MYKEYBINPUT.S_key_INPUT.dwFlags, 0 
					invoke SendInput,1,Offset MYKEYBINPUT, 28
					
					
					add edi, 1
					cmp byte ptr [edi], "'"
					jne @B
					
		    	;------------------------------------------
				; Release shift if necessary
		    	;------------------------------------------
					.if ShiftIsPressed!=FALSE
						mov MYKEYBINPUT.S_key_INPUT.wVk, VK_SHIFT
						mov MYKEYBINPUT.S_key_INPUT.dwFlags, KEYEVENTF_KEYUP
						invoke SendInput,1,Offset MYKEYBINPUT, 28
					.endif
					
					
					
	.elseif edx==KW_KEYUP_STR 
	
			mov edi, dword ptr Param2
			
			;------------------------------------------
			; Adjust to beginning of string
			;------------------------------------------
			
		    	mov ShiftIsPressed, FALSE
		    	
			;------------------------------------------
			; SCRAMBLE ASCII INTO VIRTUAL KEYCODE
			;------------------------------------------
			
			@@:
				movzx eax, byte ptr [edi]
				invoke VkKeyScan, eax
				
		    	;------------------------------------------
				; Test for shift
		    	;------------------------------------------
		    	
		    		
		    	
					mov MYKEYBINPUT.S_key_INPUT.dwFlags, 0
					mov MYKEYBINPUT.S_key_INPUT.wVk, VK_SHIFT
					
					push eax
					bt eax, 8
					.if CARRY?
			    	;------------------------------------------
					; Press shift if necessary
			    	;------------------------------------------
						.if ShiftIsPressed==FALSE
							mov ShiftIsPressed, TRUE
							invoke SendInput,1,Offset MYKEYBINPUT, 28
						.endif
					.else
			    	;------------------------------------------
					; Release shift if necessary
			    	;------------------------------------------
						.if ShiftIsPressed!=FALSE
							mov ShiftIsPressed, FALSE
							mov MYKEYBINPUT.S_key_INPUT.dwFlags, KEYEVENTF_KEYUP
							invoke SendInput,1,Offset MYKEYBINPUT, 28
						.endif
					.endif
					pop eax
					
		    	;------------------------------------------
				; Send VK code
		    	;------------------------------------------
					mov MYKEYBINPUT.S_key_INPUT.wVk, ax
					mov MYKEYBINPUT.S_key_INPUT.dwFlags, KEYEVENTF_KEYUP
					invoke SendInput,1,Offset MYKEYBINPUT, 28
					
					
					add edi, 1
					cmp byte ptr [edi], "'"
					jne @B
					
		    	;------------------------------------------
				; Release shift if necessary
		    	;------------------------------------------
					.if ShiftIsPressed!=FALSE
						mov MYKEYBINPUT.S_key_INPUT.wVk, VK_SHIFT
						invoke SendInput,1,Offset MYKEYBINPUT, 28
					.endif
					
	.elseif edx==KW_SET_INT
	
			mov eax, Param1
			mov ecx, Param2
			.if [eax].ITEM.pName != 0
				mov [eax].ITEM.pData, ecx
			.endif
			
	.elseif edx==KW_LABEL_INT
	
			mov eax, Param1
			mov ecx, CurrentLine
			mov [eax].ITEM.pData, ecx
				
			; Only need to do once!
			;mov dword ptr [esi+ebx], KW_FLAG_BLANK 
				
	.elseif edx==KW_CMP_INT
	
			mov eax, Param1
			mov ecx, Param2
			.if [eax].ITEM.pName != 0
				cmp [eax].ITEM.pData, ecx
				lahf
				mov FlagSave, eax
			.else
				mov dword ptr [esi+ebx], KW_FLAG_SYNTAX
			.endif
			
	.elseif edx==KW_JE_INT
			mov eax, FlagSave
			sahf
			jne @F
				mov ecx, Param1
				.if [ecx].ITEM.pName != 0
					mov eax, [ecx].ITEM.pData
					mov NextLine, eax
				.else
					mov dword ptr [esi+ebx], KW_FLAG_SYNTAX
				.endif
			@@:
	.elseif edx==KW_JNE_INT
			mov eax, FlagSave
			sahf
			je @F
				mov ecx, Param1
				.if [ecx].ITEM.pName != 0
					mov eax, [ecx].ITEM.pData
					mov NextLine, eax
				.else
					mov dword ptr [esi+ebx], KW_FLAG_SYNTAX
				.endif
			@@:
	.elseif edx==KW_ADD_INT
	
			mov eax, Param1
			mov ecx, Param2
			.if [eax].ITEM.pName != 0
				add [eax].ITEM.pData, ecx
			.else
				mov dword ptr [esi+ebx], KW_FLAG_SYNTAX
			.endif
			
	.elseif edx==KW_SUB_INT
	
			mov eax, Param1
			mov ecx, Param2
			.if [eax].ITEM.pName != 0
				sub [eax].ITEM.pData, ecx
			.else
				mov dword ptr [esi+ebx], KW_FLAG_SYNTAX
			.endif
			
	.elseif edx==KW_WAIT_INT
	
 			mov WaitFlag, TRUE
			invoke SetTimer,hwnd, IDT_TIMER1,Param1,0
			
	.elseif edx==KW_JMP_INT
	
			mov eax, Param1
			mov NextLine, eax

	.elseif edx==KW_QUIT_INT
	
			mov HaltFlag, TRUE
			invoke PostMessage,hwnd,WM_MACRO,IDM_HALT_MACRO,0 ; stop
		
	.elseif edx==KW_FLAG_BLANK
	
			; BLANK FLAG: SKIP 
		
	.elseif edx==KW_FLAG_SYNTAX
	
			; YELLOW FLAG: SKIP 
			
	.else ; Failure
	
		invoke DWItoDWH,edx
		mov dword ptr runerrnum, eax
		
		mov eax,CurrentLine
		shl eax, 4 ; * 16
		mov dword ptr MicroCode[eax], KW_FLAG_SYNTAX
		invoke InvalidateRect,hwnd,0,TRUE
		invoke MessageBox, NULL, Offset Error_InternalInvalidKeyword, Offset runerr , MB_OK

	.endif
  
	ret
RunMacro EndP




DestructMacro PROC uses esi edi ebx
 LOCAL CurrentLine:DWORD,
 	   Param3:DWORD,
 	   Param2:DWORD,
 	   Param1:DWORD,
 	   Instruction:DWORD
 
 
 	
		mov ebx, OpcodeLineCount 	; Get line
		sub ebx, 1
		mov esi, Offset MicroCode
		
	@@:
		mov eax, ebx
		shl eax, 4
		push dword ptr [esi+eax]
		push dword ptr [esi+eax+4]
		push dword ptr [esi+eax+8]
		push dword ptr [esi+eax+12]
		pop Param3
		pop Param2
		pop Param1
		pop Instruction
  
		.if Instruction<0
			mov eax, dword ptr Param1
			invoke HeapFree, hHeap, 0, eax
		.endif
		sub ebx, 1
	jnc @B
	
	
	ret
DestructMacro ENDP





atoi PROC pStr:DWORD
LOCAL IsNegative:BOOL

	mov IsNegative, FALSE
	xor eax, eax
	mov edx, pStr
	
;------------------------------------------------------------------
; Check if it's negative
;------------------------------------------------------------------
	.if byte ptr [edx] == '-'
		mov IsNegative, TRUE
		add edx, 1
	.endif
	
isletter:
	movzx ecx, byte ptr [edx]
	cmp ecx, '0'
	jb error
	cmp ecx, '9'
	ja error
	
	sub ecx, '0'
	lea eax, [eax*4+eax] ; eax*=5
	lea eax, [eax*2+ecx] ; eax= eax*2 + ecx
	
	add edx, 1
	jmp isletter
error:
	.if IsNegative!=FALSE
		neg eax
	.endif
	Ret
atoi EndP


; result >> pStr
itoa PROC uses ebx i:DWORD, pStr:DWORD
    mov ebx,10
	mov eax, i
	mov ecx, pStr
	
	  sub esp, 1			; .. push byte
	  mov byte ptr [esp], 0 ; .. push byte
repzz:
	xor edx,edx
	div ebx		; divide ebx by 10, put remainder in edx
	add edx, 30h
	  sub esp, 1			 ; .. push byte
	  mov byte ptr [esp], dl ; .. push byte
	test eax, eax
	jnz repzz
	
	xor eax, eax
unrepzz:
	 mov al, byte ptr [esp] ; ... pop byte
	 mov byte ptr [ecx], al ; ... pop byte
	 add esp, 1				; ... pop byte
	add ecx, 1
	test eax, eax
	jnz unrepzz
	
	Ret
itoa ENDP





DWItoDWA PROC DWI:DWORD
LOCAL xresult:DWORD

	mov eax, DWI
	mov ecx, 10
	
	xor edx, edx
	div ecx
	mov byte ptr xresult+3, dl
	
	xor edx, edx
	div ecx
	mov byte ptr xresult+2, dl
	
	xor edx, edx
	div ecx
	mov byte ptr xresult+1, dl
	
	xor edx, edx
	div ecx
	mov byte ptr xresult, dl
	
	mov eax, xresult
	add eax, 030303030h
	
	ret
DWItoDWA ENDP

.data
hexchart db '0123456789ABCDEF',0
.code
DWItoDWH PROC DWI:DWORD
LOCAL xresult:DWORD

	mov eax, DWI
	mov ecx, 16
	
	xor edx, edx
	div ecx
	mov dl, hexchart[edx]
	mov byte ptr xresult+3, dl
	
	xor edx, edx
	div ecx
	mov dl, hexchart[edx]
	mov byte ptr xresult+2, dl
	
	xor edx, edx
	div ecx
	mov dl, hexchart[edx]
	mov byte ptr xresult+1, dl
	
	xor edx, edx
	div ecx
	mov dl, hexchart[edx]
	mov byte ptr xresult, dl
	
	mov eax, xresult
	
	ret
DWItoDWH ENDP

;  convert A a B b C c D d ->0A 0B 0C 0D 0a 0b 0c 0d
; (convert nibbles to bytes....., i.e. put 00 before each nibble)
; do each one individually, then convert back

; @@ If byte is 10 or more, let it equal 37h (10 less than 'A') 
							;   else let it equal 30h ('A')
; @@ Thus, if it is more, then set it to 7h.   Afterwards, add original value + 30h.
	
DWItoQWH proc i:DWORD
LOCAL v:DWORD
		xor ecx, ecx
		movd mm0, ecx
		movd mm2, ecx
	
			mov eax, i
		
		; swap nibbles {  v = ((v >> 4) & 0x0F0F0F0F) | ((v & 0x0F0F0F0F) << 4);  }
			mov ecx, eax
			
			shr eax, 4
			and eax, 00F0F0F0Fh
			and ecx, 00F0F0F0Fh
			shl ecx, 4
			or eax, ecx
			
		; swap bytes {  v = ((v >> 8) ) | ((v  << 8);  }
			mov ecx, eax
			
			shr eax, 8
			shl ecx, 8
			or eax, ecx
			
		
			mov i, eax
		
	; @@ Convert 4 nibbles to 4 bytes
		movd mm3,i 				; 00 00 00 00 12 34 56 78
		movd mm1,i 				; 00 00 00 00 12 34 56 78
		pand mm3, qNibbleMaskH 	; 00 00 00 00 10 30 50 70
		psrlw mm3, 4	   	  	; 00 00 00 00 02 04 06 08
		pand mm1, qNibbleMaskL 	; 00 00 00 00 02 04 06 08
		PUNPCKLBW mm0, mm1	   	; 10 00 30 00 50 00 70 00
		psrld mm0, 8 	   		; 00 02 00 04 00 06 00 08
		PUNPCKLBW mm2, mm3		; 01 00 03 00 05 00 07 00
		por mm0, mm2			; 01 02 03 04 05 06 07 08

	; @@ Convert to ASCII
		movq mm2, mm0
		pcmpgtb mm0, qNineMask
		pand mm0, qSetToSeven
		paddb mm0, qAddThirty
		paddb mm0, mm2
		pand mm0, qKillTrailingBytes
	Ret ; mm1
DWItoQWH EndP

; 00FFFFFF
DisplayError proc lineNum:DWORD, szError:DWORD
	.if ContinueErrorFlag==IDOK
		invoke itoa, lineNum, Offset ErrorLineStringNumber
		invoke MessageBox, NULL, Offset Error_InvalidKeyword, Offset ErrorLineString, MB_OKCANCEL
		mov ContinueErrorFlag, eax
	.endif
	ret
DisplayError EndP























; Does same as GetItem but uses data as string.  Not really used.
SetItemFromList PROC uses esi edi ebx pItem:DWORD

	;-----------------------------
	; cmps ROOTITEM, pItem
	;-----------------------------
	
		lea ebx, ROOTITEM
		mov edx, pItem
		
	;-----------------------------
	; Compare Strings 
	;-----------------------------
	CompareNextString:
	
		mov esi,    [ebx].ITEM.pName
		mov edi, 	[edx].ITEM.pName
		mov ecx,    [ebx].ITEM.dwNameLength
		mov eax, 	[edx].ITEM.dwNameLength
	
		cmp	 ecx, eax
		ja	 NoSwap
		xchg eax, ecx
NoSwap:	repe cmpsb
		jne  NotEqual
		mov  eax, [ebx].ITEM.dwNameLength
		cmp  eax, [edx].ITEM.dwNameLength
NotEqual:

	;-----------------------------
	; cmp edx,   ebx
	; cmp pItem, ?
	;-----------------------------
	;-----------------------------
	; Apply Results
	;-----------------------------
	jb LessThan
	ja GreaterThan
	
	;-----------------------------
	; String already exists
	;-----------------------------
	    push [edx].ITEM.pData
		invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, [edx].ITEM.pName
		invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, [ebx].ITEM.pData
		invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, pItem
		pop [ebx].ITEM.pData
	jmp @F
	LessThan:
		.if [ebx].ITEM.pLeft!=0
			mov ebx, [ebx].ITEM.pLeft ; Branch left
			jmp CompareNextString
		.endif
		add TreeSize, 1
		mov [ebx].ITEM.pLeft, edx ; Attach left and end
	jmp @F
	GreaterThan:
		.if [ebx].ITEM.pRight!=0
			mov ebx, [ebx].ITEM.pRight ; Branch right
			jmp CompareNextString
		.endif
		add TreeSize, 1
		mov [ebx].ITEM.pRight, edx ; Attach right and end
	@@:
	
	ret
SetItemFromList ENDP

;You must make a heap ITEM zeroed, with pName set
; and get result in EAX
GetItemFromList PROC uses esi edi ebx pItem:DWORD

	;-----------------------------
	; cmps ROOTITEM, pItem
	;-----------------------------
	
		lea ebx, ROOTITEM
		mov edx, pItem
		
	;-----------------------------
	; Compare Strings 
	;-----------------------------
	CompareNextString:
	
		mov esi,    [ebx].ITEM.pName
		mov edi, 	[edx].ITEM.pName
		mov ecx,    [ebx].ITEM.dwNameLength
		mov eax, 	[edx].ITEM.dwNameLength
	
		cmp	 ecx, eax
		ja	 NoSwap
		xchg eax, ecx
NoSwap:	repe cmpsb
		jne  NotEqual
		mov  eax, [ebx].ITEM.dwNameLength
		cmp  eax, [edx].ITEM.dwNameLength
NotEqual:

	;-----------------------------
	; cmp edx,   ebx
	; cmp pItem, ?
	;-----------------------------
	jb LessThan
	ja GreaterThan
		
	;-----------------------------
	; String already exists
	;-----------------------------
		invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, [edx].ITEM.pName
		invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, pItem
		mov edx, ebx
	jmp @F
	LessThan:
		.if [ebx].ITEM.pLeft!=0
			mov ebx, [ebx].ITEM.pLeft ; Branch left
			jmp CompareNextString
		.endif
		add TreeSize, 1
		mov [ebx].ITEM.pLeft, edx ; Attach left and end
	jmp @F
	GreaterThan:
		.if [ebx].ITEM.pRight!=0
			mov ebx, [ebx].ITEM.pRight ; Branch right
			jmp CompareNextString
		.endif
		add TreeSize, 1
		mov [ebx].ITEM.pRight, edx ; Attach right and end
	@@:
	mov eax, edx
	ret
GetItemFromList ENDP

DeleteItemFromList PROC pItem:DWORD

	.if pItem!=0
	
		mov eax, pItem
		invoke DeleteItemFromList, [eax].ITEM.pRight
		
		mov eax, pItem
		invoke DeleteItemFromList, [eax].ITEM.pLeft
		
		mov eax, pItem
		.if [eax].ITEM.pData!=0
	 	 invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, [eax].ITEM.pData
		.endif
		
		
	 	invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, pItem

		;-------------------------------------
		; Update global count
		;-------------------------------------
			sub TreeSize, 1
			invoke DWItoDWA,TreeSize
			mov TreeSizeA, eax
			invoke InvalidateRect,hwnd,Offset myTextRect,TRUE
	.endif
	
	ret
DeleteItemFromList ENDP





; 

align 4

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

szCopyx proc src:DWORD,dst:DWORD,siz:DWORD

    mov [esp-4],  esi

    mov esi, [esp+4]
    mov edx, [esp+8]

    mov ecx, -4

  align 4
  @@:
    add ecx, 4
    
    movzx eax, BYTE PTR [esi+ecx]
    mov [edx+ecx], al
	sub dword ptr [esp+12], 1
    jc @F

    movzx eax, BYTE PTR [esi+ecx+1]
    mov [edx+ecx+1], al
	sub dword ptr [esp+12], 1
    jc @F

    movzx eax, BYTE PTR [esi+ecx+2]
    mov [edx+ecx+2], al
	sub dword ptr [esp+12], 1
    jc @F

    movzx eax, BYTE PTR [esi+ecx+3]
    mov [edx+ecx+3], al
	sub dword ptr [esp+12], 1
    jnc @B
    
  @@:
    mov esi, [esp-4]
    ret 12

szCopyx endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
; 


; 
align 4
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
AtimesB PROC A:DWORD, B:DWORD
    mov [esp-4],  ebx
    
    
    mov ebx, [esp+4]
    mov edx, [esp+8]
	xor eax, eax ; << result 
	
  			align 4
			;----------------------
			; Do ebx*edx
			;----------------------
			NextBit:
			
				;----------------------
				; if (b and 1)
				;----------------------
				 mov ecx, edx  ; ecx =   ???1 | ???0
				 and ecx, 1    ; ecx =   0001 | 0000
				 neg ecx       ; ecx =   1111 | 0000
				 and ecx, ebx  ; ecx =    ebx | 0000
				
					;----------------------
					;   then (eax += a)
					;----------------------
						add eax, ecx
				
				;----------------------
				; a<<1  ...  b>>1
				;----------------------
				
					shr edx, 1
					shl ebx, 1
				
				;----------------------
				; while b != 0
				;----------------------
				
					test edx,edx
					jnz NextBit
				
			    
    mov ebx, [esp-4]
    ret 8
AtimesB ENDP
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
; 




PixelsToMickeys PROC pPoint:DWORD

    mov ecx, pPoint
    
    ;X * 65535 / ResolutionX 
    xor edx, edx
    mov eax, [ecx].POINT.x
    shl eax, 16
    ;sub eax, [ecx].POINT.x
    div myDevMode.DEVMODE.dmPelsWidth
    mov [ecx].POINT.x, eax
    
    ;Y * 65535 / ResolutionY
    xor edx, edx
    mov eax, [ecx].POINT.y
    shl eax, 16
   ; sub eax, [ecx].POINT.y
    div myDevMode.DEVMODE.dmPelsHeight
    mov [ecx].POINT.y, eax


	ret
PixelsToMickeys ENDP
End Start